.SH
NMI HANDLING
.LP
QNX provides no direct support for handling NMI; however it does permit
programs to take control of it.
This directory contains example source for installing an NMI handler in
QNX.  The rules for nmi handlers are quite restrictive:
.IP
Interrupts are disabled while NMI handlers execute.
.IP
NMIs do not nest.
.IP
NMI handlers cannot invoke any kernel calls.
.IP
NMI handlers cannot return proxy-values like regular interrupt handlers.
.LP
The function \fIinstall_nmi\fP installs an nmi handler and
\fIuninstall_nmi\fP removes it.
This source is meant to be illustrative, real programs will need changes
to handle errors, and disable nmi sources.
The following files are provided:
.IP nmi.h
\- external definitions for nmi setup
.IP nmi.s
\- 'raw' nmi handler, setups up C environ and invokes user handler.
.IP install.c
\- code to install and remove NMI handlers.
.IP main.c
\- sample program which installs an nmi handler, and loops sleeping and
printing the value of the number of nmi's received.
.IP mknmi.c
\- sample program which simulates an NMI by issuing an "int 0x2" instruction.
.LP
Notice the compile-time flag \fIISFLAT\fP required by \fCinstall.c\fP and
\fCnmi.s\fP.
Because this source is highly dependent upon the runtime environment, this
flag is necessary.
Rarely is such a switch required.
